#line 1 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
#line 1 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 71 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_init( uint8_t address_id );
#line 83 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 97 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 21 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
static uint8_t _i2c_hw_address;
#line 37 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
static unsigned int( *start_i2c_p )( void );
static unsigned int( *write_i2c_p )( unsigned char slave_address,
 unsigned char *buffer,
 unsigned long count,
 unsigned long end_mode );
static void( *read_i2c_p )( unsigned char slave_address,
 unsigned char *buffer,
 unsigned long count,
 unsigned long end_mode );
#line 122 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
extern sfr sbit EVT_PIN;
extern sfr sbit ALM_PIN;
#line 132 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
void timer_hal_init( uint8_t address_id )
{



 start_i2c_p = I2C_Start_Ptr;
 write_i2c_p = I2C_Write_Ptr;
 read_i2c_p = I2C_Read_Ptr;
#line 214 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
 _i2c_hw_address = address_id;
#line 218 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
}


void timer_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count )
{
 uint8_t temp[  256  ];
 uint8_t cmd_size =  1 ;
 uint16_t i = 0;
 uint8_t *temp_ptr = temp;
 uint8_t *buff_ptr = buffer;
 uint8_t *cmd_ptr = command;

 while( cmd_size-- )
 temp[ i++ ] = *( cmd_ptr++ );

 while ( count-- )
 temp[ i++ ] = *( buff_ptr++ );



 start_i2c_p();
 write_i2c_p( _i2c_hw_address, temp_ptr, i, END_MODE_STOP );
#line 279 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
}

void timer_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count )
{
 uint8_t *cmd_ptr = command;
 uint8_t *buff_ptr = buffer;
 uint8_t cmd_size =  1 ;



 start_i2c_p();
 write_i2c_p( _i2c_hw_address, cmd_ptr, cmd_size, END_MODE_RESTART );
 read_i2c_p( _i2c_hw_address, buff_ptr, count, END_MODE_STOP );
#line 364 "C:/Users/Viktor/Desktop/timer_click/STM32/timer_hal.c"
}
