_Display_Init:
;Timer_click.c,25 :: 		void Display_Init(){
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timer_click.c,26 :: 		TFT_Init_ILI9341_8bit(320, 240);
MOVS	R1, #240
MOVW	R0, #320
BL	_TFT_Init_ILI9341_8bit+0
;Timer_click.c,27 :: 		TFT_BLED = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;Timer_click.c,28 :: 		TFT_Set_Pen(CL_AQUA, 1);
MOVS	R1, #1
MOVW	R0, #4095
BL	_TFT_Set_Pen+0
;Timer_click.c,29 :: 		TFT_Fill_Screen(CL_AQUA);
MOVW	R0, #4095
BL	_TFT_Fill_Screen+0
;Timer_click.c,30 :: 		TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_TFT_defaultFont+0)
MOVT	R0, #hi_addr(_TFT_defaultFont+0)
BL	_TFT_Set_Font+0
;Timer_click.c,31 :: 		TFT_Set_Pen(CL_AQUA, 1);
MOVS	R1, #1
MOVW	R0, #4095
BL	_TFT_Set_Pen+0
;Timer_click.c,33 :: 		TFT_Set_Brush(1, CL_AQUA, 0, LEFT_TO_RIGHT, CL_AQUA, CL_AQUA);
MOVW	R1, #4095
MOVW	R0, #4095
PUSH	(R1)
PUSH	(R0)
MOVS	R3, #1
MOVS	R2, #0
MOVW	R1, #4095
MOVS	R0, #1
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
;Timer_click.c,35 :: 		TFT_Write_Text("Event count: ",10,10);
MOVW	R0, #lo_addr(?lstr1_Timer_click+0)
MOVT	R0, #hi_addr(?lstr1_Timer_click+0)
MOVS	R2, #10
MOVS	R1, #10
BL	_TFT_Write_Text+0
;Timer_click.c,36 :: 		TFT_Write_Text("Time count: ",10,50);
MOVW	R0, #lo_addr(?lstr2_Timer_click+0)
MOVT	R0, #hi_addr(?lstr2_Timer_click+0)
MOVS	R2, #50
MOVS	R1, #10
BL	_TFT_Write_Text+0
;Timer_click.c,37 :: 		}
L_end_Display_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Display_Init
_MCU_Init:
;Timer_click.c,39 :: 		void MCU_Init() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timer_click.c,40 :: 		GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_1);
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;Timer_click.c,41 :: 		GPIO_Digital_Input(&GPIOC_BASE, _GPIO_PINMASK_1);
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Digital_Input+0
;Timer_click.c,42 :: 		TIMER_EVT = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
STR	R1, [R0, #0]
;Timer_click.c,43 :: 		I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;Timer_click.c,44 :: 		delay_ms(200);
MOVW	R7, #40703
MOVT	R7, #36
NOP
NOP
L_MCU_Init0:
SUBS	R7, R7, #1
BNE	L_MCU_Init0
NOP
NOP
NOP
;Timer_click.c,45 :: 		}
L_end_MCU_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _MCU_Init
_main:
;Timer_click.c,47 :: 		void main() {
;Timer_click.c,48 :: 		MCU_Init();
BL	_MCU_Init+0
;Timer_click.c,49 :: 		timer_hal_init(DS1682_I2C_Adr);
MOVS	R0, #107
BL	_timer_hal_init+0
;Timer_click.c,50 :: 		Display_Init();
BL	_Display_Init+0
;Timer_click.c,59 :: 		while(1) {
L_main2:
;Timer_click.c,60 :: 		delay_ms(2000);
MOVW	R7, #13823
MOVT	R7, #366
NOP
NOP
L_main4:
SUBS	R7, R7, #1
BNE	L_main4
NOP
NOP
NOP
;Timer_click.c,61 :: 		TFT_Rectangle(100,10,200,40);
MOVS	R3, #40
SXTH	R3, R3
MOVS	R2, #200
SXTH	R2, R2
MOVS	R1, #10
SXTH	R1, R1
MOVS	R0, #100
SXTH	R0, R0
BL	_TFT_Rectangle+0
;Timer_click.c,62 :: 		TFT_Rectangle(80,50,200,80);
MOVS	R3, #80
SXTH	R3, R3
MOVS	R2, #200
SXTH	R2, R2
MOVS	R1, #50
SXTH	R1, R1
MOVS	R0, #80
SXTH	R0, R0
BL	_TFT_Rectangle+0
;Timer_click.c,64 :: 		EC = timer_Get_ec_Value();
BL	_timer_get_ec_value+0
MOVW	R1, #lo_addr(_EC+0)
MOVT	R1, #hi_addr(_EC+0)
STRH	R0, [R1, #0]
;Timer_click.c,65 :: 		WordToStr(EC,text);
MOVW	R1, #lo_addr(_text+0)
MOVT	R1, #hi_addr(_text+0)
BL	_WordToStr+0
;Timer_click.c,66 :: 		TFT_Write_Text(text,100,10);
MOVS	R2, #10
MOVS	R1, #100
MOVW	R0, #lo_addr(_text+0)
MOVT	R0, #hi_addr(_text+0)
BL	_TFT_Write_Text+0
;Timer_click.c,68 :: 		ETC = timer_get_etc_value();
BL	_timer_get_etc_value+0
MOVW	R1, #lo_addr(_ETC+0)
MOVT	R1, #hi_addr(_ETC+0)
STR	R0, [R1, #0]
;Timer_click.c,69 :: 		LongWordToStr(ETC,text);
MOVW	R1, #lo_addr(_text+0)
MOVT	R1, #hi_addr(_text+0)
BL	_LongWordToStr+0
;Timer_click.c,70 :: 		TFT_Write_Text(text,100,50);
MOVS	R2, #50
MOVS	R1, #100
MOVW	R0, #lo_addr(_text+0)
MOVT	R0, #hi_addr(_text+0)
BL	_TFT_Write_Text+0
;Timer_click.c,71 :: 		}
IT	AL
BAL	L_main2
;Timer_click.c,73 :: 		}
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
