#line 1 "C:/Users/Viktor/Desktop/timer_click/STM32/Timer_click.c"
#line 1 "c:/users/viktor/desktop/timer_click/stm32/timer_hw.h"
#line 1 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 71 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_init( uint8_t address_id );
#line 83 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 97 "c:/users/viktor/desktop/timer_click/stm32/timer_hal.h"
void timer_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 4 "c:/users/viktor/desktop/timer_click/stm32/timer_hw.h"
void timer_read_eeprom(uint8_t* buffer, uint8_t count);

void timer_write_eeprom(uint8_t* buffer, uint8_t count);

uint32_t timer_get_etc_value();

void timer_set_etc_value(uint32_t _value);

uint16_t timer_get_ec_value();

void timer_set_ec_value(uint16_t _value);

uint16_t timer_get_alarm_value();
#line 26 "c:/users/viktor/desktop/timer_click/stm32/timer_hw.h"
void set_alarm_value(uint32_t _value);
#line 35 "c:/users/viktor/desktop/timer_click/stm32/timer_hw.h"
void timer_set_write_disable();
#line 44 "c:/users/viktor/desktop/timer_click/stm32/timer_hw.h"
void timer_set_write_memory_disable();


int8_t alarm_output_select(uint8_t select);

void reset_enable( _Bool  enable);

int8_t set_alarm_polarity(uint8_t polarity);



void timer_reset_device();
#line 9 "C:/Users/Viktor/Desktop/timer_click/STM32/Timer_click.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;


sbit TIMER_EVT at GPIOD_ODR.B1;
sbit TIMER_ALM at GPIOC_IDR.B1;

char text[24];
unsigned long ETC;
unsigned int EC;

void Display_Init(){
 TFT_Init_ILI9341_8bit(320, 240);
 TFT_BLED = 1;
 TFT_Set_Pen(CL_AQUA, 1);
 TFT_Fill_Screen(CL_AQUA);
 TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
 TFT_Set_Pen(CL_AQUA, 1);

 TFT_Set_Brush(1, CL_AQUA, 0, LEFT_TO_RIGHT, CL_AQUA, CL_AQUA);

 TFT_Write_Text("Event count: ",10,10);
 TFT_Write_Text("Time count: ",10,50);
}

void MCU_Init() {
 GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_1);
 GPIO_Digital_Input(&GPIOC_BASE, _GPIO_PINMASK_1);
 TIMER_EVT = 1;
 I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
 delay_ms(200);
}

void main() {
 MCU_Init();
 timer_hal_init( 0x6B );
 Display_Init();
#line 59 "C:/Users/Viktor/Desktop/timer_click/STM32/Timer_click.c"
 while(1) {
 delay_ms(2000);
 TFT_Rectangle(100,10,200,40);
 TFT_Rectangle(80,50,200,80);

 EC = timer_Get_ec_Value();
 WordToStr(EC,text);
 TFT_Write_Text(text,100,10);

 ETC = timer_get_etc_value();
 LongWordToStr(ETC,text);
 TFT_Write_Text(text,100,50);
 }

}
