_timer_hal_init:
;timer_hal.c,132 :: 		void timer_hal_init( uint8_t address_id )
; address_id start address is: 0 (R0)
; address_id end address is: 0 (R0)
; address_id start address is: 0 (R0)
;timer_hal.c,137 :: 		start_i2c_p         = I2C_Start_Ptr;
MOVW	R1, #lo_addr(_I2C_Start_Ptr+0)
MOVT	R1, #hi_addr(_I2C_Start_Ptr+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(timer_hal_start_i2c_p+0)
MOVT	R1, #hi_addr(timer_hal_start_i2c_p+0)
STR	R2, [R1, #0]
;timer_hal.c,138 :: 		write_i2c_p         = I2C_Write_Ptr;
MOVW	R1, #lo_addr(_I2C_Write_Ptr+0)
MOVT	R1, #hi_addr(_I2C_Write_Ptr+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(timer_hal_write_i2c_p+0)
MOVT	R1, #hi_addr(timer_hal_write_i2c_p+0)
STR	R2, [R1, #0]
;timer_hal.c,139 :: 		read_i2c_p          = I2C_Read_Ptr;
MOVW	R1, #lo_addr(_I2C_Read_Ptr+0)
MOVT	R1, #hi_addr(_I2C_Read_Ptr+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(timer_hal_read_i2c_p+0)
MOVT	R1, #hi_addr(timer_hal_read_i2c_p+0)
STR	R2, [R1, #0]
;timer_hal.c,214 :: 		_i2c_hw_address = address_id;
MOVW	R1, #lo_addr(timer_hal__i2c_hw_address+0)
MOVT	R1, #hi_addr(timer_hal__i2c_hw_address+0)
STRB	R0, [R1, #0]
; address_id end address is: 0 (R0)
;timer_hal.c,218 :: 		}
L_end_timer_hal_init:
BX	LR
; end of _timer_hal_init
_timer_hal_write:
;timer_hal.c,223 :: 		uint8_t count )
; count start address is: 8 (R2)
; buffer start address is: 4 (R1)
; command start address is: 0 (R0)
SUB	SP, SP, #268
STR	LR, [SP, #0]
MOV	R5, R1
; count end address is: 8 (R2)
; buffer end address is: 4 (R1)
; command end address is: 0 (R0)
; command start address is: 0 (R0)
; buffer start address is: 20 (R5)
; count start address is: 8 (R2)
;timer_hal.c,226 :: 		uint8_t cmd_size = COMMAND_SIZE;
; cmd_size start address is: 4 (R1)
MOVS	R1, #1
;timer_hal.c,227 :: 		uint16_t i = 0;
; i start address is: 16 (R4)
MOVW	R4, #0
;timer_hal.c,228 :: 		uint8_t *temp_ptr = temp;
ADD	R3, SP, #12
; temp_ptr start address is: 12 (R3)
;timer_hal.c,229 :: 		uint8_t *buff_ptr = buffer;
; buff_ptr start address is: 24 (R6)
MOV	R6, R5
; buffer end address is: 20 (R5)
;timer_hal.c,230 :: 		uint8_t *cmd_ptr = command;
; cmd_ptr start address is: 20 (R5)
MOV	R5, R0
; command end address is: 0 (R0)
; cmd_size end address is: 4 (R1)
; i end address is: 16 (R4)
; temp_ptr end address is: 12 (R3)
; cmd_ptr end address is: 20 (R5)
; count end address is: 8 (R2)
; buff_ptr end address is: 24 (R6)
MOV	R0, R6
MOV	R6, R5
UXTB	R5, R1
MOV	R1, R3
UXTH	R7, R4
;timer_hal.c,232 :: 		while( cmd_size-- )
L_timer_hal_write0:
; cmd_ptr start address is: 24 (R6)
; cmd_size start address is: 20 (R5)
; buff_ptr start address is: 0 (R0)
; temp_ptr start address is: 4 (R1)
; i start address is: 28 (R7)
; cmd_size start address is: 20 (R5)
; count start address is: 8 (R2)
UXTB	R4, R5
SUBS	R3, R5, #1
UXTB	R5, R3
; cmd_size end address is: 20 (R5)
CMP	R4, #0
IT	EQ
BEQ	L_timer_hal_write1
; cmd_size end address is: 20 (R5)
;timer_hal.c,233 :: 		temp[ i++ ] = *( cmd_ptr++ );
; cmd_size start address is: 20 (R5)
ADD	R3, SP, #12
ADDS	R4, R3, R7
LDRB	R3, [R6, #0]
STRB	R3, [R4, #0]
ADDS	R7, R7, #1
UXTH	R7, R7
ADDS	R6, R6, #1
; cmd_size end address is: 20 (R5)
; cmd_ptr end address is: 24 (R6)
IT	AL
BAL	L_timer_hal_write0
L_timer_hal_write1:
;timer_hal.c,235 :: 		while ( count-- )
MOV	R6, R0
; temp_ptr end address is: 4 (R1)
; count end address is: 8 (R2)
; i end address is: 28 (R7)
MOV	R0, R1
UXTB	R1, R2
L_timer_hal_write2:
; buff_ptr end address is: 0 (R0)
; count start address is: 4 (R1)
; count start address is: 4 (R1)
; i start address is: 28 (R7)
; temp_ptr start address is: 0 (R0)
; buff_ptr start address is: 24 (R6)
UXTB	R4, R1
SUBS	R3, R1, #1
UXTB	R1, R3
; count end address is: 4 (R1)
CMP	R4, #0
IT	EQ
BEQ	L_timer_hal_write3
; count end address is: 4 (R1)
;timer_hal.c,236 :: 		temp[ i++ ] = *( buff_ptr++ );
; count start address is: 4 (R1)
ADD	R3, SP, #12
ADDS	R5, R3, R7
LDRB	R4, [R6, #0]
STRB	R4, [R5, #0]
ADDS	R7, R7, #1
UXTH	R7, R7
ADDS	R6, R6, #1
; count end address is: 4 (R1)
; buff_ptr end address is: 24 (R6)
IT	AL
BAL	L_timer_hal_write2
L_timer_hal_write3:
;timer_hal.c,240 :: 		start_i2c_p();
MOVW	R4, #lo_addr(timer_hal_start_i2c_p+0)
MOVT	R4, #hi_addr(timer_hal_start_i2c_p+0)
LDR	R4, [R4, #0]
STR	R0, [SP, #4]
STRH	R7, [SP, #8]
BLX	R4
LDRH	R7, [SP, #8]
LDR	R0, [SP, #4]
;timer_hal.c,241 :: 		write_i2c_p( _i2c_hw_address, temp_ptr, i, END_MODE_STOP );
MOVW	R3, #lo_addr(timer_hal__i2c_hw_address+0)
MOVT	R3, #hi_addr(timer_hal__i2c_hw_address+0)
LDRB	R3, [R3, #0]
UXTH	R2, R7
MOV	R1, R0
; i end address is: 28 (R7)
UXTB	R0, R3
; temp_ptr end address is: 0 (R0)
MOVW	R3, #1
MOVW	R4, #lo_addr(timer_hal_write_i2c_p+0)
MOVT	R4, #hi_addr(timer_hal_write_i2c_p+0)
LDR	R4, [R4, #0]
BLX	R4
;timer_hal.c,279 :: 		}
L_end_timer_hal_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #268
BX	LR
; end of _timer_hal_write
_timer_hal_read:
;timer_hal.c,283 :: 		uint8_t count )
; buffer start address is: 4 (R1)
; command start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
MOV	R4, R0
MOV	R5, R1
STRB	R2, [SP, #16]
; buffer end address is: 4 (R1)
; command end address is: 0 (R0)
; command start address is: 16 (R4)
; buffer start address is: 20 (R5)
;timer_hal.c,285 :: 		uint8_t *cmd_ptr = command;
STR	R4, [SP, #4]
; command end address is: 16 (R4)
;timer_hal.c,286 :: 		uint8_t *buff_ptr = buffer;
STR	R5, [SP, #8]
; buffer end address is: 20 (R5)
;timer_hal.c,287 :: 		uint8_t cmd_size = COMMAND_SIZE;
MOVS	R4, #1
STRB	R4, [SP, #12]
;timer_hal.c,291 :: 		start_i2c_p();
MOVW	R4, #lo_addr(timer_hal_start_i2c_p+0)
MOVT	R4, #hi_addr(timer_hal_start_i2c_p+0)
LDR	R4, [R4, #0]
BLX	R4
;timer_hal.c,292 :: 		write_i2c_p( _i2c_hw_address, cmd_ptr, cmd_size, END_MODE_RESTART );
MOVW	R3, #lo_addr(timer_hal__i2c_hw_address+0)
MOVT	R3, #hi_addr(timer_hal__i2c_hw_address+0)
LDRB	R3, [R3, #0]
LDRB	R2, [SP, #12]
LDR	R1, [SP, #4]
UXTB	R0, R3
MOVW	R3, #0
MOVW	R4, #lo_addr(timer_hal_write_i2c_p+0)
MOVT	R4, #hi_addr(timer_hal_write_i2c_p+0)
LDR	R4, [R4, #0]
BLX	R4
;timer_hal.c,293 :: 		read_i2c_p( _i2c_hw_address, buff_ptr, count, END_MODE_STOP );
MOVW	R3, #lo_addr(timer_hal__i2c_hw_address+0)
MOVT	R3, #hi_addr(timer_hal__i2c_hw_address+0)
LDRB	R3, [R3, #0]
LDRB	R2, [SP, #16]
LDR	R1, [SP, #8]
UXTB	R0, R3
MOVW	R3, #1
MOVW	R4, #lo_addr(timer_hal_read_i2c_p+0)
MOVT	R4, #hi_addr(timer_hal_read_i2c_p+0)
LDR	R4, [R4, #0]
BLX	R4
;timer_hal.c,364 :: 		}
L_end_timer_hal_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _timer_hal_read
